<?php 
$controller = 'Size';
$action = '';
if(isset($_POST['action'])){
    $action = $_POST['action'];
    if (isset($_POST['id'])) {$id = $_POST['id'];}
}elseif(isset($_GET['action'])){
    $action = $_GET['action'];
    if (isset($_GET['id'])) {$id = $_GET['id'];}
}
include $_SERVER["DOCUMENT_ROOT"].'/app/include/bootstrap.php';

$_form = new TamanoForm();
$_tamano = new TamanoEntity();
$_listaTamanos = $_tamano->getListaTamanos();
switch($action){
    case 'insert':
        $_form->populate($_POST);
        if($_form->isValid()){
            $_tamano->setOptions($_POST);
            $result = $_tamano->save($_tamano->getOptions());
            if($result){
                $flashmessenger->addMessage(array('success'=>'Genial !! El Tamaño se registro exitosamente.'));
                header('Location: Size.php');
            }else{
                $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
            }
        }else{
            $vista = 'Tamano.php';
            include $root.'/View/Template.php';
        }
        break;
   
    case 'edit':
        if($_GET){$_tamanoData = $_tamano->getById($id);}
        if($_POST){$_tamanoData = $_POST;}
        
        $_form->setActionController('edit');
        $_form->setId($id);
        $_form->populate($_tamanoData);
        
        if(isset($_POST['id'])){
            if($_form->isValid()){
                $_tamano->setOptions($_tamanoData);
                $result = $_tamano->update($id,$_tamano->getOptions()); //no tengo id porque viene de post
                if($result){
                    $flashmessenger->addMessage(array('success'=>'Estupendo !! El Tamaño se actualizo exitosamente.'));
                    header("Location: Size.php?action=edit&id=$id");
                }else{
                    $flashmessenger->addMessage(array('danger'=>'Error. Intenta nuevamente o contacta a tu proveedor de sistemas.'));
                }       
            }else{
                $vista = 'Tamano.php';
                include $root . '/View/Template.php';
            }
        }else{
            $vista = 'Tamano.php';
            include $root . '/View/Template.php';
        }        
        break;
    
    case 'delete': 
        if(!$_tamano->isUsedInRecord($id)){
            if($_tamano->delete($id)){
                $flashmessenger->addMessage(array('success'=>'Hecho !! El Tamaño fue eliminado satisfactoriamente.'));
            }
        }else{
            $message = 'Hola !! esta Tamano no puede ser eliminado, esta siendo utilizado en almenos un registro.';
            $flashmessenger->addMessage(array('info'=>$message));
        }
        header('Location: Size.php');
        break;
    
    default:
        $vista = 'Tamano.php';
        include $root.'/View/Template.php';
}